Index: /trunk/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -316,8 +316,6 @@
   const Pel* const  piRefSrch = rcStruct.piRefY + iSearchY * rcStruct.iYStride + iSearchX;
 
-#if NH_3D_IC
+#if NH_3D
   m_cDistParam.bUseIC = pcPatternKey->getICFlag();
-#endif
-#if NH_3D_SDC_INTER
   m_cDistParam.bUseSDCMRSAD = pcPatternKey->getSDCMRSADFlag();
 #endif
@@ -848,5 +846,30 @@
   const TComMv* pcMvRefine = (iFrac == 2 ? s_acMvRefineH : s_acMvRefineQ);
 
+#if MCTS_ENC_CHECK
+  UInt maxRefinements = 9;
+  Int mvShift = 2;
+
+  // filter length of sub-sample generation filter to be considered
+  const UInt LumaLTSampleOffset = 3;
+  const UInt LumaRBSampleOffset = 4;
+
+  if (m_pcEncCfg->getTMCTSSEITileConstraint())
+  {
+    // if close to tile borders
+    if ( pcPatternKey->getROIYPosX() + (baseRefMv.getHor() >> mvShift ) < pcPatternKey->getTileLeftTopPelPosX() +  LumaLTSampleOffset ||
+         pcPatternKey->getROIYPosY() + (baseRefMv.getVer() >> mvShift ) < pcPatternKey->getTileLeftTopPelPosY() +  LumaLTSampleOffset ||
+         pcPatternKey->getROIYPosX() + (baseRefMv.getHor() >> mvShift)  > pcPatternKey->getTileRightBottomPelPosX() - pcPatternKey->getROIYWidth() - LumaRBSampleOffset ||
+         pcPatternKey->getROIYPosY() + (baseRefMv.getVer() >> mvShift)  > pcPatternKey->getTileRightBottomPelPosY() - pcPatternKey->getROIYHeight() - LumaRBSampleOffset  
+       )
+    {
+      // only allow full pel positions to avoid filter dependency
+      maxRefinements = 1;
+    }
+  }  
+
+  for (UInt i = 0; i < maxRefinements; i++)
+#else
   for (UInt i = 0; i < 9; i++)
+#endif
   {
     TComMv cMvTest = pcMvRefine[i];
@@ -868,8 +891,6 @@
 
     setDistParamComp(COMPONENT_Y);
-#if NH_3D_IC
+#if NH_3D
     m_cDistParam.bUseIC = pcPatternKey->getICFlag();
-#endif
-#if NH_3D_SDC_INTER
     m_cDistParam.bUseSDCMRSAD = pcPatternKey->getSDCMRSADFlag();
 #endif
@@ -1020,56 +1041,53 @@
       if( !pcCU->getSlice()->isIntra() )
       {
-        if (pcCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
+        if (pcCU->getSlice()->getPPS()->getTransquantBypassEnabledFlag())
         {
           m_pcEntropyCoder->encodeCUTransquantBypassFlag( pcCU, 0, true );
         }
         m_pcEntropyCoder->encodeSkipFlag( pcCU, 0, true );
-#if NH_3D_DIS
+#if NH_3D
         m_pcEntropyCoder->encodeDIS(pcCU, 0, true );
         if(!pcCU->getDISFlag(uiAbsPartIdx))
 #endif
-        m_pcEntropyCoder->encodePredMode( pcCU, 0, true );
-      }
-#if NH_3D_DIS
+          m_pcEntropyCoder->encodePredMode( pcCU, 0, true );
+      }
+#if NH_3D
       else
       {
         m_pcEntropyCoder->encodeDIS(pcCU, 0, true );
       }
-#endif
-#if NH_3D_DIS
       if(!pcCU->getDISFlag(uiAbsPartIdx))
       {
 #endif
-      m_pcEntropyCoder  ->encodePartSize( pcCU, 0, pcCU->getDepth(0), true );
-
-      if (pcCU->isIntra(0) && pcCU->getPartitionSize(0) == SIZE_2Nx2N )
-      {
-        m_pcEntropyCoder->encodeIPCMInfo( pcCU, 0, true );
-
-        if ( pcCU->getIPCMFlag (0))
-        {
-#if NH_3D_SDC_INTRA
+        m_pcEntropyCoder  ->encodePartSize( pcCU, 0, pcCU->getDepth(0), true );
+
+        if (pcCU->isIntra(0) && pcCU->getPartitionSize(0) == SIZE_2Nx2N )
+        {
+          m_pcEntropyCoder->encodeIPCMInfo( pcCU, 0, true );
+
+          if ( pcCU->getIPCMFlag (0))
+          {
+#if NH_3D
             m_pcEntropyCoder->encodeSDCFlag( pcCU, 0, true );
 #endif
-          return;
-        }
-      }
-#if NH_3D_DIS
-    }
-#endif
-  }
-#if NH_3D_DIS
+            return;
+          }
+        }
+#if NH_3D
+      }
+#endif
+    }
+#if NH_3D
     if(!pcCU->getDISFlag(uiAbsPartIdx))
     {
 #endif
-    // luma prediction mode
-    if( pcCU->getPartitionSize(0) == SIZE_2Nx2N )
-    {
-      if (uiAbsPartIdx==0)
-      {
-        m_pcEntropyCoder->encodeIntraDirModeLuma ( pcCU, 0 );
-#if NH_3D_SDC_INTRA
+      // luma prediction mode
+      if( pcCU->getPartitionSize(0) == SIZE_2Nx2N )
+      {
+        if (uiAbsPartIdx==0)
+        {
+          m_pcEntropyCoder->encodeIntraDirModeLuma ( pcCU, 0 );
+#if NH_3D
           m_pcEntropyCoder->encodeSDCFlag( pcCU, 0, true );
-#if NH_3D_DMM
           if( pcCU->getSlice()->getIsDepth() && ( !pcCU->getSDCFlag( 0 ) ) && isDmmMode( pcCU->getIntraDir( CHANNEL_TYPE_LUMA, 0 ) ) )
           {
@@ -1077,27 +1095,22 @@
           }
 #endif
-#endif
-      }
-    }
-    else
-    {
-      UInt uiQNumParts = pcCU->getTotalNumPart() >> 2;
-      if (uiTrDepth>0 && (uiAbsPartIdx%uiQNumParts)==0)
-      {
-        m_pcEntropyCoder->encodeIntraDirModeLuma ( pcCU, uiAbsPartIdx );
-#if NH_3D_SDC_INTRA
+        }
+      }
+      else
+      {
+        UInt uiQNumParts = pcCU->getTotalNumPart() >> 2;
+        if (uiTrDepth>0 && (uiAbsPartIdx%uiQNumParts)==0)
+        {
+          m_pcEntropyCoder->encodeIntraDirModeLuma ( pcCU, uiAbsPartIdx );
+#if NH_3D
           if( uiAbsPartIdx == 0 )  
           {
             m_pcEntropyCoder->encodeSDCFlag( pcCU, 0, true );
           }
-#if NH_3D_DMM
           if( pcCU->getSlice()->getIsDepth() && ( !pcCU->getSDCFlag( uiAbsPartIdx ) ) && isDmmMode( pcCU->getIntraDir( CHANNEL_TYPE_LUMA, uiAbsPartIdx ) ) )
           {
             m_pcEntropyCoder->encodeDeltaDC( pcCU, uiAbsPartIdx );
           }
-#endif
-#endif
-#if NH_3D_DIS
-      }
+        }
 #endif
       }
@@ -1180,5 +1193,5 @@
                                       DEBUG_STRING_FN_DECLARE(sDebug)
                                            ,Int         default0Save1Load2
-#if NH_3D_ENC_DEPTH
+#if NH_3D
                                           , Bool        zeroResiFlag
 #endif
@@ -1253,5 +1266,5 @@
 
     //===== get prediction signal =====
-#if NH_3D_DMM
+#if NH_3D
     if( bIsLuma && isDmmMode( uiChFinalMode ) )
     {
@@ -1262,5 +1275,5 @@
 #endif
     predIntraAng( compID, uiChFinalMode, piOrg, uiStride, piPred, uiStride, rTu, bUseFilteredPredictions );
-#if NH_3D_DMM
+#if NH_3D
     }
 #endif
@@ -1309,5 +1322,5 @@
     for( UInt uiY = 0; uiY < uiHeight; uiY++ )
     {
-#if NH_3D_ENC_DEPTH
+#if NH_3D
       if( zeroResiFlag )
       {
@@ -1318,16 +1331,15 @@
       {
 #endif
-      for( UInt uiX = 0; uiX < uiWidth; uiX++ )
-      {
-        pResi[ uiX ] = pOrg[ uiX ] - pPred[ uiX ];
-      }
-
-      pOrg  += uiStride;
-      pResi += uiStride;
-      pPred += uiStride;
-#if NH_3D_ENC_DEPTH
-      }
-#endif
-
+        for( UInt uiX = 0; uiX < uiWidth; uiX++ )
+        {
+          pResi[ uiX ] = pOrg[ uiX ] - pPred[ uiX ];
+        }
+
+        pOrg  += uiStride;
+        pResi += uiStride;
+        pPred += uiStride;
+#if NH_3D
+      }
+#endif
     }
   }
@@ -1353,5 +1365,6 @@
   if( useTransformSkip ? m_pcEncCfg->getUseRDOQTS() : m_pcEncCfg->getUseRDOQ() )
   {
-    m_pcEntropyCoder->estimateBit( m_pcTrQuant->m_pcEstBitsSbac, uiWidth, uiHeight, chType );
+    COEFF_SCAN_TYPE scanType = COEFF_SCAN_TYPE(pcCU->getCoefScanIdx(uiAbsPartIdx, uiWidth, uiHeight, compID));
+    m_pcEntropyCoder->estimateBit( m_pcTrQuant->m_pcEstBitsSbac, uiWidth, uiHeight, chType, scanType );
   }
 
@@ -1518,5 +1531,5 @@
                                     TComTU&     rTu
                                     DEBUG_STRING_FN_DECLARE(sDebug)
-#if NH_3D_ENC_DEPTH
+#if NH_3D
                                   , Bool        zeroResiFlag
 #endif                                
@@ -1576,5 +1589,5 @@
   }
 #endif
-#if NH_3D_DMM
+#if NH_3D
   if( isDmmMode( pcCU->getIntraDir( CHANNEL_TYPE_LUMA, uiAbsPartIdx ) ) )
   {
@@ -1707,5 +1720,5 @@
       //----- code luma/chroma block with given intra prediction mode and store Cbf-----
       dSingleCost   = 0.0;
-#if NH_3D_ENC_DEPTH
+#if NH_3D
       xIntraCodingTUBlock( pcOrgYuv, pcPredYuv, pcResiYuv, resiLumaSingle, false, uiSingleDistLuma, COMPONENT_Y, rTu DEBUG_STRING_PASS_INTO(sDebug), 0, zeroResiFlag );
 #else
@@ -1886,5 +1899,5 @@
 }
 
-#if NH_3D_DIS
+#if NH_3D
 #if NH_3D_VSO
 Void TEncSearch::xIntraCodingDIS( TComDataCU* pcCU, UInt uiAbsPartIdx, TComYuv* pcOrgYuv, TComYuv* pcPredYuv, Dist&       ruiDist, Double& dRDCost, UInt uiPredMode )
@@ -1984,6 +1997,5 @@
     dRDCost = m_pcRdCost->calcRdCost( uiBits, ruiDist );
 }
-#endif
-#if NH_3D_SDC_INTRA
+
 #if NH_3D_VSO
 Void TEncSearch::xIntraCodingSDC( TComDataCU* pcCU, UInt uiAbsPartIdx, TComYuv* pcOrgYuv, TComYuv* pcPredYuv, Dist&       ruiDist, Double& dRDCost, Bool bZeroResidual, Int iSDCDeltaResi  )
@@ -1991,6 +2003,4 @@
 Void TEncSearch::xIntraCodingSDC( TComDataCU* pcCU, UInt uiAbsPartIdx, TComYuv* pcOrgYuv, TComYuv* pcPredYuv, Distortion& ruiDist, Double& dRDCost, Bool bZeroResidual, Int iSDCDeltaResi  )
 #endif
-
-
 {
   UInt uiWidth        = pcCU->getWidth ( 0 );
@@ -2016,5 +2026,5 @@
   Bool* pbMask = NULL;
   UInt uiMaskStride = 0;
-#if NH_3D_DMM
+
   if( isDmmMode( uiLumaPredMode ) )
   {
@@ -2064,5 +2074,5 @@
   else // regular HEVC intra modes
   {
-#endif
+
     uiNumSegments = 1;
     
@@ -2125,7 +2135,5 @@
     predConstantSDC( piPred, uiStride, uiWidth, apDCPredValues[0] ); apDCPredValues[1] = 0;
     xCalcConstantSDC( piOrg, uiStride, uiWidth, apDCOrigValues[0] ); apDCOrigValues[1] = 0;
-#if NH_3D_DMM  
-  }
-#endif
+  }
 
   for( UInt uiSegment = 0; uiSegment < uiNumSegments; uiSegment++ )
@@ -2134,12 +2142,7 @@
     Pel pDCRec = ( !bZeroResidual ) ? apDCOrigValues[uiSegment] : apDCPredValues[uiSegment];
     // get residual (idx)
-#if NH_3D_DLT
     Pel pResidualIdx = pcCU->getSlice()->getPPS()->getDLT()->depthValue2idx( pcCU->getSlice()->getLayerIdInVps(), pDCRec ) - pcCU->getSlice()->getPPS()->getDLT()->depthValue2idx( pcCU->getSlice()->getLayerIdInVps(), apDCPredValues[uiSegment] );
-#else
-    Pel pResidualIdx = pDCRec - apDCPredValues[uiSegment];
-#endif
     if( !bZeroResidual )
     {
-#if NH_3D_DLT
       Pel   pPredIdx    = pcCU->getSlice()->getPPS()->getDLT()->depthValue2idx( pcCU->getSlice()->getLayerIdInVps(), apDCPredValues[uiSegment] );
       Int   pTestIdx    = pPredIdx + pResidualIdx + iSDCDeltaResi;
@@ -2148,7 +2151,4 @@
         pResidualIdx += iSDCDeltaResi;
       }
-#else
-      pResidualIdx += iSDCDeltaResi;
-#endif
     }
     // save SDC DC offset
@@ -2160,5 +2160,4 @@
   for( UInt uiSegment = 0; uiSegment < uiNumSegments; uiSegment++ )
   {
-#if NH_3D_DLT
     Pel   pPredIdx    = pcCU->getSlice()->getPPS()->getDLT()->depthValue2idx( pcCU->getSlice()->getLayerIdInVps(), apDCPredValues[uiSegment] );
     Pel   pResiIdx    = pcCU->getSDCSegmentDCOffset(uiSegment, uiAbsPartIdx);
@@ -2166,7 +2165,4 @@
 
     apDCResiValues[uiSegment]  = pRecoValue - apDCPredValues[uiSegment];
-#else
-    apDCResiValues[uiSegment]  = pcCU->getSDCSegmentDCOffset(uiSegment, uiAbsPartIdx);
-#endif
   }
 
@@ -2212,7 +2208,8 @@
   }
 
-#if NH_3D_DMM
-  if( pbMask ) { delete[] pbMask; }
-#endif
+  if( pbMask ) 
+  { 
+    delete[] pbMask; 
+  }
 
   //===== determine distortion =====  
@@ -2225,9 +2222,5 @@
 #endif
   {
-#if NH_3D_FIX_INTRA_SDC_VSO_OFF
     ruiDist = m_pcRdCost->getDistPart( bitDepthY, piPred, uiStride, piOrg, uiStride, uiWidth, uiHeight, COMPONENT_Y );
-#else
-    ruiDist = m_pcRdCost->getDistPart( bitDepthY, piPred, uiStride, piOrg, uiStride, uiWidth, uiHeight, COMPONENT_Y, DF_SAD );
-#endif
   }
 
@@ -2238,5 +2231,5 @@
   if( !pcCU->getSlice()->isIntra() )
   {
-    if (pcCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
+    if (pcCU->getSlice()->getPPS()->getTransquantBypassEnabledFlag())
     {
       m_pcEntropyCoder->encodeCUTransquantBypassFlag( pcCU, 0, true );
@@ -2737,5 +2730,5 @@
 }
 
-#if NH_3D_DIS
+#if NH_3D
 Void TEncSearch::estIntraPredDIS( TComDataCU* pcCU, 
                                   TComYuv*    pcOrgYuv, 
@@ -2746,7 +2739,6 @@
                                   Bool        bLumaOnly )
 {
-#if NH_MV
+
   D_PRINT_INC_INDENT(g_traceModeCheck, "estIntraPredDis");
-#endif
 
   UInt    uiDepth        = pcCU->getDepth(0);
@@ -2828,5 +2820,5 @@
                                Pel         resiLuma[NUMBER_OF_STORED_RESIDUAL_TYPES][MAX_CU_SIZE * MAX_CU_SIZE]
                                DEBUG_STRING_FN_DECLARE(sDebug)
-#if NH_3D_ENC_DEPTH
+#if NH_3D
                              , Bool        bOnlyIVP
 #endif
@@ -2908,5 +2900,5 @@
     assert (tuRecurseWithPU.ProcessComponentSection(COMPONENT_Y));
     initIntraPatternChType( tuRecurseWithPU, COMPONENT_Y, true DEBUG_STRING_PASS_INTO(sTemp2) );
-#if NH_3D_ENC_DEPTH
+#if NH_3D
     if( bOnlyIVP )
     {
@@ -2917,15 +2909,131 @@
 #endif
 
-    Bool doFastSearch = (numModesForFullRD != numModesAvailable);
-    if (doFastSearch)
-    {
-      assert(numModesForFullRD < numModesAvailable);
-
-      for( Int i=0; i < numModesForFullRD; i++ )
-      {
-        CandCostList[ i ] = MAX_DOUBLE;
-      }
-      CandNum = 0;
-
+      Bool doFastSearch = (numModesForFullRD != numModesAvailable);
+      if (doFastSearch)
+      {
+        assert(numModesForFullRD < numModesAvailable);
+
+        for( Int i=0; i < numModesForFullRD; i++ )
+        {
+          CandCostList[ i ] = MAX_DOUBLE;
+        }
+        CandNum = 0;
+
+        const TComRectangle &puRect=tuRecurseWithPU.getRect(COMPONENT_Y);
+        const UInt uiAbsPartIdx=tuRecurseWithPU.GetAbsPartIdxTU();
+
+        Pel* piOrg         = pcOrgYuv ->getAddr( COMPONENT_Y, uiAbsPartIdx );
+        Pel* piPred        = pcPredYuv->getAddr( COMPONENT_Y, uiAbsPartIdx );
+        UInt uiStride      = pcPredYuv->getStride( COMPONENT_Y );
+        DistParam distParam;
+        const Bool bUseHadamard=pcCU->getCUTransquantBypass(0) == 0;
+        m_pcRdCost->setDistParam(distParam, sps.getBitDepth(CHANNEL_TYPE_LUMA), piOrg, uiStride, piPred, uiStride, puRect.width, puRect.height, bUseHadamard);
+
+#if NH_3D
+        distParam.bUseIC = false;
+        distParam.bUseSDCMRSAD = false;
+#endif
+        distParam.bApplyWeight = false;
+        for( Int modeIdx = 0; modeIdx < numModesAvailable; modeIdx++ )
+        {
+          UInt       uiMode = modeIdx;
+#if !NH_3D_VSO
+          Distortion uiSad  = 0;
+#endif
+#if NH_MV
+          D_PRINT_INC_INDENT(g_traceModeCheck, "preTest; uiMode " + n2s(uiMode) );
+#endif
+          const Bool bUseFilter=TComPrediction::filteringIntraReferenceSamples(COMPONENT_Y, uiMode, puRect.width, puRect.height, chFmt, sps.getSpsRangeExtension().getIntraSmoothingDisabledFlag());
+
+          predIntraAng( COMPONENT_Y, uiMode, piOrg, uiStride, piPred, uiStride, tuRecurseWithPU, bUseFilter, TComPrediction::UseDPCMForFirstPassIntraEstimation(tuRecurseWithPU, uiMode) );
+#if NH_3D_VSO // M34
+          Dist uiSad;           
+          if ( m_pcRdCost->getUseVSO() )
+          {
+            if ( m_pcRdCost->getUseEstimatedVSD() )
+            {          
+              uiSad = (Dist) ( m_pcRdCost->getDistPartVSD( pcCU, uiPartOffset, distParam.bitDepth , piPred, uiStride, piOrg, uiStride, distParam.iCols, distParam.iRows, true ) );
+            }
+            else
+            {    
+              uiSad = m_pcRdCost->getDistPartVSO( pcCU, uiPartOffset, distParam.bitDepth , piPred, uiStride, piOrg, uiStride, distParam.iCols, distParam.iRows, true );
+            }
+          }
+          else
+          {
+            uiSad = distParam.DistFunc(&distParam);
+          }
+#else        
+          // use hadamard transform here
+          uiSad+=distParam.DistFunc(&distParam);
+#endif
+
+          UInt   iModeBits = 0;
+
+          // NB xModeBitsIntra will not affect the mode for chroma that may have already been pre-estimated.
+          iModeBits+=xModeBitsIntra( pcCU, uiMode, uiPartOffset, uiDepth, CHANNEL_TYPE_LUMA );
+
+#if NH_3D_VSO // M35
+          Double dLambda;
+          if ( m_pcRdCost->getUseLambdaScaleVSO() )
+          {
+            dLambda = m_pcRdCost->getUseRenModel() ? m_pcRdCost->getLambdaVSO() : sqrtLambdaForFirstPass;
+          }
+          else        
+          {
+            dLambda = m_pcRdCost->getSqrtLambda();        
+          }
+
+          Double cost      = (Double)uiSad + (Double)iModeBits * dLambda;
+#else
+          Double cost      = (Double)uiSad + (Double)iModeBits * sqrtLambdaForFirstPass;
+#endif
+
+#if DEBUG_INTRA_SEARCH_COSTS
+          std::cout << "1st pass mode " << uiMode << " SAD = " << uiSad << ", mode bits = " << iModeBits << ", cost = " << cost << "\n";
+#endif
+
+          CandNum += xUpdateCandList( uiMode, cost, numModesForFullRD, uiRdModeList, CandCostList );
+#if NH_MV
+          D_DEC_INDENT( g_traceModeCheck ); 
+#endif
+        }
+
+        if (m_pcEncCfg->getFastUDIUseMPMEnabled())
+        {
+          Int uiPreds[NUM_MOST_PROBABLE_MODES] = {-1, -1, -1};
+
+          Int iMode = -1;
+          pcCU->getIntraDirPredictor( uiPartOffset, uiPreds, COMPONENT_Y, &iMode );
+
+          const Int numCand = ( iMode >= 0 ) ? iMode : Int(NUM_MOST_PROBABLE_MODES);
+
+          for( Int j=0; j < numCand; j++)
+          {
+            Bool mostProbableModeIncluded = false;
+            Int mostProbableMode = uiPreds[j];
+
+            for( Int i=0; i < numModesForFullRD; i++)
+            {
+              mostProbableModeIncluded |= (mostProbableMode == uiRdModeList[i]);
+            }
+            if (!mostProbableModeIncluded)
+            {
+              uiRdModeList[numModesForFullRD++] = mostProbableMode;
+            }
+          }
+        }
+      }
+      else
+      {
+        for( Int i=0; i < numModesForFullRD; i++)
+        {
+          uiRdModeList[i] = i;
+        }
+      }
+#if NH_3D
+    }
+    if( m_pcEncCfg->getIsDepth() )
+    {
       const TComRectangle &puRect=tuRecurseWithPU.getRect(COMPONENT_Y);
       const UInt uiAbsPartIdx=tuRecurseWithPU.GetAbsPartIdxTU();
@@ -2934,131 +3042,8 @@
       Pel* piPred        = pcPredYuv->getAddr( COMPONENT_Y, uiAbsPartIdx );
       UInt uiStride      = pcPredYuv->getStride( COMPONENT_Y );
-      DistParam distParam;
-      const Bool bUseHadamard=pcCU->getCUTransquantBypass(0) == 0;
-      m_pcRdCost->setDistParam(distParam, sps.getBitDepth(CHANNEL_TYPE_LUMA), piOrg, uiStride, piPred, uiStride, puRect.width, puRect.height, bUseHadamard);
-
-#if NH_3D
-      distParam.bUseIC = false;
-#endif
-#if NH_3D_SDC_INTER
-      distParam.bUseSDCMRSAD = false;
-#endif
-      distParam.bApplyWeight = false;
-      for( Int modeIdx = 0; modeIdx < numModesAvailable; modeIdx++ )
-      {
-        UInt       uiMode = modeIdx;
-#if !NH_3D_VSO
-        Distortion uiSad  = 0;
-#endif
-#if NH_MV
-        D_PRINT_INC_INDENT(g_traceModeCheck, "preTest; uiMode " + n2s(uiMode) );
-#endif
-
-        const Bool bUseFilter=TComPrediction::filteringIntraReferenceSamples(COMPONENT_Y, uiMode, puRect.width, puRect.height, chFmt, sps.getSpsRangeExtension().getIntraSmoothingDisabledFlag());
-
-        predIntraAng( COMPONENT_Y, uiMode, piOrg, uiStride, piPred, uiStride, tuRecurseWithPU, bUseFilter, TComPrediction::UseDPCMForFirstPassIntraEstimation(tuRecurseWithPU, uiMode) );
-#if NH_3D_VSO // M34
-        Dist uiSad;           
-        if ( m_pcRdCost->getUseVSO() )
-        {
-          if ( m_pcRdCost->getUseEstimatedVSD() )
-          {          
-            uiSad = (Dist) ( m_pcRdCost->getDistPartVSD( pcCU, uiPartOffset, distParam.bitDepth , piPred, uiStride, piOrg, uiStride, distParam.iCols, distParam.iRows, true ) );
-          }
-          else
-          {    
-            uiSad = m_pcRdCost->getDistPartVSO( pcCU, uiPartOffset, distParam.bitDepth , piPred, uiStride, piOrg, uiStride, distParam.iCols, distParam.iRows, true );
-          }
-        }
-        else
-        {
-          uiSad = distParam.DistFunc(&distParam);
-        }
-#else        
-        // use hadamard transform here
-        uiSad+=distParam.DistFunc(&distParam);
-#endif
-
-        UInt   iModeBits = 0;
-
-        // NB xModeBitsIntra will not affect the mode for chroma that may have already been pre-estimated.
-        iModeBits+=xModeBitsIntra( pcCU, uiMode, uiPartOffset, uiDepth, CHANNEL_TYPE_LUMA );
-
-#if NH_3D_VSO // M35
-        Double dLambda;
-        if ( m_pcRdCost->getUseLambdaScaleVSO() )
-        {
-          dLambda = m_pcRdCost->getUseRenModel() ? m_pcRdCost->getLambdaVSO() : sqrtLambdaForFirstPass;
-        }
-        else        
-        {
-          dLambda = m_pcRdCost->getSqrtLambda();        
-        }
-
-        Double cost      = (Double)uiSad + (Double)iModeBits * dLambda;
-#else
-        Double cost      = (Double)uiSad + (Double)iModeBits * sqrtLambdaForFirstPass;
-#endif
-
-#if DEBUG_INTRA_SEARCH_COSTS
-        std::cout << "1st pass mode " << uiMode << " SAD = " << uiSad << ", mode bits = " << iModeBits << ", cost = " << cost << "\n";
-#endif
-
-        CandNum += xUpdateCandList( uiMode, cost, numModesForFullRD, uiRdModeList, CandCostList );
-#if NH_MV
-        D_DEC_INDENT( g_traceModeCheck ); 
-#endif
-      }
-
-      if (m_pcEncCfg->getFastUDIUseMPMEnabled())
-      {
-      Int uiPreds[NUM_MOST_PROBABLE_MODES] = {-1, -1, -1};
-
-      Int iMode = -1;
-      pcCU->getIntraDirPredictor( uiPartOffset, uiPreds, COMPONENT_Y, &iMode );
-
-      const Int numCand = ( iMode >= 0 ) ? iMode : Int(NUM_MOST_PROBABLE_MODES);
-
-      for( Int j=0; j < numCand; j++)
-      {
-        Bool mostProbableModeIncluded = false;
-        Int mostProbableMode = uiPreds[j];
-
-        for( Int i=0; i < numModesForFullRD; i++)
-        {
-          mostProbableModeIncluded |= (mostProbableMode == uiRdModeList[i]);
-        }
-        if (!mostProbableModeIncluded)
-        {
-          uiRdModeList[numModesForFullRD++] = mostProbableMode;
-        }
-      }
-    }
-    }
-    else
-    {
-      for( Int i=0; i < numModesForFullRD; i++)
-      {
-        uiRdModeList[i] = i;
-      }
-    }
-#if NH_3D_ENC_DEPTH
-    }
-#endif
-
-#if NH_3D_DMM
-    if( m_pcEncCfg->getIsDepth() )
-    {
-      const TComRectangle &puRect=tuRecurseWithPU.getRect(COMPONENT_Y);
-      const UInt uiAbsPartIdx=tuRecurseWithPU.GetAbsPartIdxTU();
-
-      Pel* piOrg         = pcOrgYuv ->getAddr( COMPONENT_Y, uiAbsPartIdx );
-      Pel* piPred        = pcPredYuv->getAddr( COMPONENT_Y, uiAbsPartIdx );
-      UInt uiStride      = pcPredYuv->getStride( COMPONENT_Y );
 
       if( puRect.width >= DMM_MIN_SIZE && puRect.width <= DMM_MAX_SIZE &&  puRect.width == puRect.height &&
-          ((m_pcEncCfg->getUseDMM() &&  pcCU->getSlice()->getIntraSdcWedgeFlag()) || pcCU->getSlice()->getIntraContourFlag()) )
-      {
-#if NH_3D_ENC_DEPTH
+        ((m_pcEncCfg->getUseDMM() &&  pcCU->getSlice()->getIntraSdcWedgeFlag()) || pcCU->getSlice()->getIntraContourFlag()) )
+      {
         if( bOnlyIVP )
         {
@@ -3082,12 +3067,8 @@
           if( uiRdModeList[0] != PLANAR_IDX || varCU >= varThreshold )
           {
-#endif
             UInt startIdx = ( m_pcEncCfg->getUseDMM() &&  pcCU->getSlice()->getIntraSdcWedgeFlag() ) ? 0 : 1;
             UInt endIdx   = (                             pcCU->getSlice()->getIntraContourFlag()  ) ? 1 : 0;
             for( UInt dmmType = startIdx; dmmType <= endIdx; dmmType++ )
             {
-#if H_3D_FCO
-              if ( !(pcCU->getSlice()->getIvPic(false, pcCU->getSlice()->getViewIndex() )->getReconMark()) && (DMM4_IDX == dmmType ) ) { continue; }
-#endif
               Bool* biSegPattern  = new Bool[ puRect.width*puRect.height ];
               UInt  patternStride = puRect.width;
@@ -3114,13 +3095,11 @@
                 pcCU->setDmmDeltaDC( (DmmID)dmmType, 0, uiPartOffset, deltaDC1 );
                 pcCU->setDmmDeltaDC( (DmmID)dmmType, 1, uiPartOffset, deltaDC2 );
-  
+
                 uiRdModeList[ numModesForFullRD++ ] = (dmmType+DMM_OFFSET);
                 delete[] biSegPattern;
               }
             }
-#if NH_3D_ENC_DEPTH
           }
         }
-#endif
       }
     }
@@ -3134,5 +3113,5 @@
     DEBUG_STRING_NEW(sPU)
     UInt       uiBestPUMode  = 0;
-#if NH_3D_ENC_DEPTH
+#if NH_3D
     UInt    uiBestPUModeConv  = 0;
     UInt    uiSecondBestPUModeConv  = 0;
@@ -3147,13 +3126,9 @@
     Double     dBestPUCost   = MAX_DOUBLE;
 
-#if NH_3D_ENC_DEPTH
+#if NH_3D
     Double  dBestPUCostConv   = MAX_DOUBLE;
     UInt rdSDC = m_pcEncCfg->getIsDepth() ? numModesForFullRD : 0;
-#endif
-#if NH_3D_SDC_INTRA
     Bool    bBestUseSDC   = false;
     Pel     apBestDCOffsets[2] = {0,0};
-#endif
-#if NH_3D_ENC_DEPTH
     for( UInt uiMode = 0; uiMode < numModesForFullRD + rdSDC; uiMode++ )
 #else
@@ -3173,9 +3148,7 @@
     {
       // set luma prediction mode
-#if !NH_3D_ENC_DEPTH
+#if !NH_3D
       UInt uiOrgMode = uiRdModeList[uiMode];
-#endif
-
-#if NH_3D_ENC_DEPTH
+#else
       UInt uiOrgMode;
       if (uiMode < numModesForFullRD)
@@ -3214,16 +3187,10 @@
       pcCU->setIntraDirSubParts ( CHANNEL_TYPE_LUMA, uiOrgMode, uiPartOffset, uiDepth + uiInitTrDepth );
 
-#if NH_3D_SDC_INTRA
-#if NH_3D_ENC_DEPTH
+#if NH_3D
       Bool bTestSDC = ( ( m_pcEncCfg->getUseSDC() &&  pcCU->getSlice()->getIntraSdcWedgeFlag() ) && pcCU->getSDCAvailable(uiPartOffset) && uiMode >= numModesForFullRD);
-#else
-      Bool bTestSDC = ( m_pcEncCfg->getUseSDC() && pcCU->getSDCAvailable(uiPartOffset) );
-#endif
 
       for( UInt uiSDC=0; uiSDC<=(bTestSDC?1:0); uiSDC++ )
       {
-#if NH_3D_ENC_DEPTH
         if (!uiSDC && uiMode >= numModesForFullRD) continue;
-#endif
         pcCU->setSDCFlagSubParts( (uiSDC != 0), uiPartOffset, uiDepth + uiInitTrDepth );
         Double dOffsetCost[3] = {MAX_DOUBLE,MAX_DOUBLE,MAX_DOUBLE};
@@ -3258,8 +3225,5 @@
             }
           }
-#endif
-#if NH_3D_ENC_DEPTH
           Bool zeroResiTest = (pcCU->getSlice()->getIsDepth() && !pcCU->getSlice()->isIRAP());
-#if NH_3D_SDC_INTRA
           zeroResiTest = zeroResiTest || pcCU->getSDCFlag(uiPartOffset);
           if( uiSDC != 0 && iSDCDeltaResi != 0 )
@@ -3267,26 +3231,25 @@
             zeroResiTest = false;
           }
-#endif
           for( UInt zeroResi = 0; zeroResi <= ( zeroResiTest ? 1 : 0 ); zeroResi++ )
           {
 #endif
-      DEBUG_STRING_NEW(sMode)
-      // set context models
-      m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[uiDepth][CI_CURR_BEST] );
-
-      // determine residual for partition
+            DEBUG_STRING_NEW(sMode)
+              // set context models
+              m_pcRDGoOnSbacCoder->load( m_pppcRDSbacCoder[uiDepth][CI_CURR_BEST] );
+
+            // determine residual for partition
 #if NH_3D_VSO
-      Dist       uiPUDistY = 0;
+            Dist       uiPUDistY = 0;
 #else
-      Distortion uiPUDistY = 0;
-#endif
-      Double     dPUCost   = 0.0;
+            Distortion uiPUDistY = 0;
+#endif
+            Double     dPUCost   = 0.0;
 #if NH_3D_VSO // M36
-      if( m_pcRdCost->getUseRenModel() )
-      {
-        m_pcRdCost->setRenModelData( pcCU, uiPartOffset, pcOrgYuv, &tuRecurseWithPU );
-      }
-#endif
-#if NH_3D_SDC_INTRA
+            if( m_pcRdCost->getUseRenModel() )
+            {
+              m_pcRdCost->setRenModelData( pcCU, uiPartOffset, pcOrgYuv, &tuRecurseWithPU );
+            }
+#endif
+#if NH_3D
             if( pcCU->getSDCFlag(uiPartOffset) )
             {
@@ -3304,9 +3267,7 @@
             {
 #endif
-
 #if HHI_RQT_INTRA_SPEEDUP
-#if NH_3D_ENC_DEPTH
-      xRecurIntraCodingLumaQT( pcOrgYuv, pcPredYuv, pcResiYuv, resiLumaPU, uiPUDistY, true, dPUCost, tuRecurseWithPU DEBUG_STRING_PASS_INTO(sMode), (zeroResi != 0) );
-#if NH_3D_ENC_DEPTH
+#if NH_3D
+              xRecurIntraCodingLumaQT( pcOrgYuv, pcPredYuv, pcResiYuv, resiLumaPU, uiPUDistY, true, dPUCost, tuRecurseWithPU DEBUG_STRING_PASS_INTO(sMode), (zeroResi != 0) );
               if( dPUCost < dBestPUCostConv )
               {
@@ -3316,37 +3277,35 @@
                 dBestPUCostConv   = dPUCost;
               }
-#endif
 #else
-      xRecurIntraCodingLumaQT( pcOrgYuv, pcPredYuv, pcResiYuv, resiLumaPU, uiPUDistY, true, dPUCost, tuRecurseWithPU DEBUG_STRING_PASS_INTO(sMode) );
+              xRecurIntraCodingLumaQT( pcOrgYuv, pcPredYuv, pcResiYuv, resiLumaPU, uiPUDistY, true, dPUCost, tuRecurseWithPU DEBUG_STRING_PASS_INTO(sMode) );
 #endif
 #else
-#if NH_3D_ENC_DEPTH
-      xRecurIntraCodingLumaQT( pcOrgYuv, pcPredYuv, pcResiYuv, resiLumaPU, uiPUDistY, dPUCost, tuRecurseWithPU DEBUG_STRING_PASS_INTO(sMode), (zeroResi != 0) );
+#if NH_3D
+              xRecurIntraCodingLumaQT( pcOrgYuv, pcPredYuv, pcResiYuv, resiLumaPU, uiPUDistY, dPUCost, tuRecurseWithPU DEBUG_STRING_PASS_INTO(sMode), (zeroResi != 0) );
 #else
-      xRecurIntraCodingLumaQT( pcOrgYuv, pcPredYuv, pcResiYuv, resiLumaPU, uiPUDistY, dPUCost, tuRecurseWithPU DEBUG_STRING_PASS_INTO(sMode) );
-#endif
-#endif
-#if NH_3D_SDC_INTRA
+              xRecurIntraCodingLumaQT( pcOrgYuv, pcPredYuv, pcResiYuv, resiLumaPU, uiPUDistY, dPUCost, tuRecurseWithPU DEBUG_STRING_PASS_INTO(sMode) );
+#endif
+#endif
+#if NH_3D
             }
 #endif
 
-
 #if DEBUG_INTRA_SEARCH_COSTS
-      std::cout << "2nd pass [luma,chroma] mode [" << Int(pcCU->getIntraDir(CHANNEL_TYPE_LUMA, uiPartOffset)) << "," << Int(pcCU->getIntraDir(CHANNEL_TYPE_CHROMA, uiPartOffset)) << "] cost = " << dPUCost << "\n";
-#endif
-
-      // check r-d cost
-      if( dPUCost < dBestPUCost )
-      {
-        DEBUG_STRING_SWAP(sPU, sMode)
+            std::cout << "2nd pass [luma,chroma] mode [" << Int(pcCU->getIntraDir(CHANNEL_TYPE_LUMA, uiPartOffset)) << "," << Int(pcCU->getIntraDir(CHANNEL_TYPE_CHROMA, uiPartOffset)) << "] cost = " << dPUCost << "\n";
+#endif
+
+            // check r-d cost
+            if( dPUCost < dBestPUCost )
+            {
+              DEBUG_STRING_SWAP(sPU, sMode)
 #if HHI_RQT_INTRA_SPEEDUP_MOD
-        uiSecondBestMode  = uiBestPUMode;
-        dSecondBestPUCost = dBestPUCost;
-#endif
-        uiBestPUMode  = uiOrgMode;
-        uiBestPUDistY = uiPUDistY;
-        dBestPUCost   = dPUCost;
-
-#if NH_3D_SDC_INTRA
+                uiSecondBestMode  = uiBestPUMode;
+              dSecondBestPUCost = dBestPUCost;
+#endif
+              uiBestPUMode  = uiOrgMode;
+              uiBestPUDistY = uiPUDistY;
+              dBestPUCost   = dPUCost;
+
+#if NH_3D
               if( pcCU->getSDCFlag(uiPartOffset) )
               {
